<template>
  <single-pane
    :capt="dictionaryRu.title"
    class="service-type-page"
  >
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :show-add-button="true"
      :add-button-text="dictionaryRu.add_button_title"
      is-fixed-header
      @select="onSelectionItem"
      @add="onAdd"
      ref="obTable"
    />
    <ob-modal
      ref="viewItem"
      custom-class="modal-extra-large"
      :title="serviceModalTitle"
      :titleSecond="this.newStatus ? 'Добавление' : 'Редактирование'"
      :is-show-pagination="!newStatus"
      @onСhangeActive="alert('test')"
    >
      <service-type
        :data-source="selectedData"
        :activites="activites"
        :isShowControls="true"
        @delete="onDelete"
        @submit="onSaveService"
        @title-changed="serviceTitle = $event"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
  import {uuid} from "vue-uuid"
  import api from "@/api";
  import { STATUS_MODEL, SERVICE_GEOGRAPHY } from '@/resources/enum';
  import ServiceType from './modal/ServiceType';
  import paging      from '@/mixins/dictionaries/paging';
  import itemMixin   from '@/mixins/dictionaries/edit-item';
  import SinglePane  from 'common-components/src/obComponents/obSinglePanels';
  import ObModal     from 'common-components/src/obComponents/obModal';
  import ObTable     from 'common-components/src/obComponents/obTable';
  import { dictionaryDefault } from '@/translations/ru/default';
  import { dictionary } from '@/translations/ru/dictionaries__services__service_types';

  export default {
    name: 'ServiceTypes',
    components: {
      ObModal,
      ServiceType,
      ObTable,
      SinglePane
    },
    mixins: [
      paging,
      itemMixin
    ],
    computed: {
      categoriesMap() {
        return {
          'COMMERCIAL': this.dictionaryRu.categories.COMMERCIAL,
          'COMPENSATION_FOR_LOSS_OR_DAMAGE': this.dictionaryRu.categories.COMPENSATION_FOR_LOSS_OR_DAMAGE,
          'SURCHARGE': this.dictionaryRu.categories.SURCHARGE,
        }
      },
      columnsObTable() {
        return [
          {
            title: this.dictionaryRu.columns.denomination,
            key: 'title',
          },
          {
            title: this.dictionaryRu.columns.activity_name,
            key: 'activity',
            html: data => data.activity.title
          },
          {
            title: this.dictionaryRu.columns.category,
            key: 'category',
            html: data => this.categoriesMap[data.category]
          },
          {
            title: this.dictionaryRu.columns.service_geography,
            key: 'service_geography',
            html: data => SERVICE_GEOGRAPHY[data.geography]
          },
          {
            title: this.dictionaryRu.columns.includedInMainService,
            key: 'includedInMainService',
            html: data => data.includedInMainService ? "<i class='icon checked'>" : ""
          }, 
          {
            title: this.dictionaryRu.columns.isVatCharged,
            key: 'isVatCharged',
            html: data => data.isVatCharged ? "<i class='icon checked'>" : ''
          },
          {
            title: this.dictionaryRu.columns.needResources,
            key: 'needResources',
            html: data => data.needResources ? "<i class='icon checked'>" : ''
          },
          {
            title: this.dictionaryRu.columns.includeInTariff,
            key: 'isIncludedInTariff',
            html: data => data.isIncludedInTariff ? "<i class='icon checked'>" : ""
          },
          {
            title: this.dictionaryRu.columns.isCalculateInBaseprice,
            key: 'isCalculateInBaseprice',
            html: data => data.isCalculateInBaseprice ? "<i class='icon checked'>" : ""
          },
          {
            title: this.dictionaryRu.columns.status_model,
            key: 'statusModel',
            html: data => data.statusModel === 'EXTENDED' ? this.dictionaryRu.STATUS_MODEL.EXTENDED : this.dictionaryRu.STATUS_MODEL.REDUCED
          },
          {
            title: this.dictionaryRu.columns.status,
            width: 110,
            key: 'isActive',
            html: data => !data.isActive ? this.dictionaryRu.statusInfo.inactive : this.dictionaryRu.statusInfo.active
          }
        ]
      },
      serviceModalTitle() {
        return this.serviceTitle || (this.newStatus ? this.dictionaryRu.modal.add_title : this.dictionaryRu.modal.view_title);
      },
      api() {
        return {
          source: '/oboz2-dictionary-service-types-crud/v2/',
          getEditSource(uuid) {
            return `/oboz2-dictionary-service-types-crud/v2/${uuid}`
          }
        }
      }
    },
    data() {
      return {
        SERVICE_GEOGRAPHY,
        STATUS_MODEL,
        activites: [],
        dataGridRefName: 'ServiceTypes',
        dictionaryRu: Object.assign(dictionary, dictionaryDefault),
        serviceTitle: ''
      }
    },
    methods: {
      async onSaveService($event) {
        try {
          const id = this.selectedData.uuid ? this.selectedData.uuid : uuid.v4()
          await api.services.createServiceType(id, $event.formData);
          this.$refs.viewItem.close();
          this.$refs.obTable.loadData();
        } catch (err) {
          console.error(err);
        }
      },
      async onSelectionItem(data) {
        this.newStatus = false;
        try {
          const _data = await this.eiGet(data);
          if (!_data || _data.error) {
            throw new Error('onSelectionItem error');
          } else {
            this.selectedData = { ..._data.data, uuid: data.uuid };
            this.$refs.viewItem.open();
          }
        } catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      }
    }
  }
</script>
<style lang="scss">
  $green: $serviceTypesPage-icon_checked_color;

  .service-type-page {
    .icon.checked {
      color: $Green-700;
    }

    table {

      tr {
        td:nth-child(5),
        td:nth-child(6),
        td:nth-child(7) {
          position: relative;

          .td-container {
            width: 100%;
            text-align: center;
            display: inline-block;

            span {
              display: inline-block;

              i {
                font-size: 16px;
              }
            }
          }
        }
      }
    }
  }
</style>
